/*
Copyright (c) 2005-2009 TeamF1, Inc.
All rights reserved.
*/

/* wan1_setup.htm and wan2_setup.htm */
function wanSetupValidate ()
    {
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtWi1LoginUsrName,Invalid ISP login information: Please enter a valid login name or ID provided by your ISP";
    txtFieldIdArr[1] = "txtWi1TypeServIpAddr,Invalid Server IP Address: Please enter a valid IP address or FQDN";
    txtFieldIdArr[2] = "txtWanConnRstHour,Please enter a valid Hours value";
    txtFieldIdArr[3] = "txtWanConnRstMin,Please enter a valid Minutes value";
    txtFieldIdArr[4] = "txtWanConnRstDelay,Please enter a valid Delay in Seconds";

    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
         
	if (validateIdleTimeout () == false)
            return false;
        
    var hoursObj = document.getElementById('txtWanConnRstHour');
    if (hoursObj && !hoursObj.disabled &&
        numericValueRangeCheck (hoursObj, '', '', 0, 23, true, "Invalid Hours value:", '') == false)
        return false;

    var minObj = document.getElementById('txtWanConnRstMin');
    if (minObj && !minObj.disabled &&
        numericValueRangeCheck (minObj, '', '', 0, 59, true, "Invalid Minutes value:", '') == false)
        return false;

    var delayObj = document.getElementById('txtWanConnRstDelay');
    if (delayObj && !delayObj.disabled &&
        numericValueRangeCheck (delayObj, '', '', 0, 59, true, "Invalid Delay value: ", 'Seconds') == false)
        return false;

    /* validate all IP addresses: check for empty and invalid values */
    if (ipv4AddrOctetsValidate ('tblWi1TypeMyIpAddr', 'IP', true, true,
             "Invalid IP address in 'My IP Address' field.", "for octet ", true) == false)
        return false;

	var isIPAddr = false;
	var svrIPObj = document.getElementById('txtWi1TypeServIpAddr');
	if (!svrIPObj.disabled)
		{
		if (svrIPObj && svrIPObj.value != "")
			{
			var ipObjArr = svrIPObj.value.split (".");
			if (ipAddrOctetCheck (ipObjArr)) isIPAddr = true;
			}
	
	    if (validateFQDN ('txtWi1TypeServIpAddr') == false)
	    	return false;
	        
	    if (ipv4AddrOctetsValidate ('tblWi1TypePPPServIpAddr', 'IP', true, true,
	             "Invalid IP address in 'Gateway IP Address' field.", "for octet ", true) == false)
	        return false;
	        
	    var myIpAddr = getIPStr('tblWi1TypeMyIpAddr');
	    var gwIPAddr = getIPStr('tblWi1TypePPPServIpAddr');
	    
		/* if "Server IP Address" is configured as FQDN, we shouldn't allow "My IP
			Address" and "Gateway IP Address" (those could be 0.0.0.0) */
	   	if(!isIPAddr && ((myIpAddr != "..." && myIpAddr != "0.0.0.0") || (gwIPAddr != "..." && gwIPAddr != "0.0.0.0")))
	   		{
	    	alert ("My IP Address and Gateway IP Address are not configurable if Server IP Address is configured as FQDN.")
	        return false;
	   		}
	   	else
	   		{
			/* if Server IP Address is configured as IP address. */
		    if (myIpAddr != "..." && myIpAddr != "0.0.0.0")
		    	{
			    var svrIpAddrInt = getIPInt1('txtWi1TypeServIpAddr');
			    var myIpAddrInt = getIPInt('tblWi1TypeMyIpAddr');
			    var snetMaskInt = getIPInt1('hdSubnetMask');
	
			    if (isInSubnet(svrIpAddrInt, myIpAddrInt, snetMaskInt))
			    	{
					/*
					  if "My IP Address" is of same subnet as "Server IP Address",
					  "Gateway IP Address" shouldn't be allowed to configure
					*/
					if (gwIPAddr != "..." && gwIPAddr != "0.0.0.0")
						{
				    	alert ("Gateway IP Address must not configurable if Server IP Address and My IP Address are in same subnet.");
				        return false;
						}
			    	}
			    else
			    	{
					/*
					  "My IP Address" can be left with 0.0.0.0 or if configured and they are in
					   different subnet than the "Server IP Address", then "Gateway IP Address"
					   shouldn't be allowed to left blank or 0.0.0.0
					*/
					if (gwIPAddr == "..." || gwIPAddr == "0.0.0.0")
						{
				    	alert ("Gateway IP Address must configure if Server IP Address and My IP Address are in different subnet.");
				        return false;
						}
		   			}
		    	}
		    else
		    	{
				/* if "Gateway IP Address" is configured without configuring "My IP Address", it shouldn't be allowed */
				if (gwIPAddr != "..." && gwIPAddr != "0.0.0.0")
					{
			    	alert ("My IP Address must configure if Gateway IP Address configured.");
			        return false;
					}
		    	}
	    	}
    	}
    	
    if (ipv4AddrOctetsValidate ('tblWi1IpAddr', 'IP', false, true,
             "Invalid static IP address.", "for octet ", true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('tblWi1IpSnetmask', 'SM', false, true,
             "Invalid IP subnet mask.", "for octet ", true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('tblWi1IpGway', 'IP', false, true,
             "Invalid Gateway IP address.", "for octet ", true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('tblWi1DNSPrimary', 'IP', false, true,
             "Invalid Primary DNS server address.", "for octet ", true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('tblWi1DNSSec', 'IP', true, true,
             "Invalid Secondary DNS server addressr.", "for octet ", true) == false)
        return false;
    return true;
    }
    
function validateIdleTimeout ()
	{
	var idleTOObj = document.getElementById('txtWi1TypeIdleTimeOut');
	if (!idleTOObj || idleTOObj.disabled) return true;
	if (idleTOObj.value == "0") return true;
	if (numericValueRangeCheck (idleTOObj, '', '', 5, 999, true, 'Invalid idle timeout value:', 'minutes') == false)
		return false;
	return true;
	}

function wan1InitalSettings ()
	{
	ipAddrCheck ();
	dnsServerCheck ();
	wan1IspAustriaEnable ();
	wan1IspOtherEnable ();
    ispLoginYesCheck ();
	ispLoginNoCheck ();
	}
	
function ispLoginYesCheck ()
	{
	if (document.getElementById('rdbWi1LoginY').checked)
		{
		fieldStateChangeWr ('', '', '', 'tblWi1LoginSection tblWi1TypeSection tblWi1IpAddrSection tblWi1DNSSection');
		wan1IspAustriaEnable ();
		wan1IspOtherEnable ();
		ipAddrCheck ();
		dnsServerCheck ();
		}
	}
	
function ispLoginNoCheck ()
	{
	if (document.getElementById('rdbWi1LoginN').checked)
		{
		fieldStateChangeWr ('', 'tblWi1LoginSection tblWi1TypeSection', '', 'tblWi1IpAddrSection tblWi1DNSSection');
		ipAddrCheck ();
		dnsServerCheck ();
		}
	}
	
function idleTimeOutCheck ()
	{
	depFieldCheck ('rdbWi1TypeKeepConn', true, 'txtWi1TypeIdleTimeOut', '', '', '');
	depFieldCheck ('rdbWi1TypeKeepConn', false, '', '', 'txtWi1TypeIdleTimeOut', '');
	depFieldCheck ('rdbWi1TypeIdleTimeOut', true, '', '', 'txtWi1TypeIdleTimeOut', '');
	depFieldCheck ('rdbWi1TypeIdleTimeOut', false, 'txtWi1TypeIdleTimeOut', '', '', '');
    idleLBCheck();
	}

function idleLBCheck ()
	{
	if (document.getElementById('hdWansLBIdleStatus') &&
        document.getElementById('hdWansLBIdleStatus').value == "1")
		{
        // Idle timeout is not allowed in LB mode
		fieldStateSet ('rdbWi1TypeKeepConn','');
		fieldStateChangeWr ('rdbWi1TypeIdleTimeOut', '', '', '');
		fieldStateChangeWr ('txtWi1TypeIdleTimeOut', '', '', '');
		}
	}
	
function wan1IspAustriaEnable ()
	{
	if (document.getElementById('rdbWi1TypeAustria').checked)
		{
		fieldStateChangeWr ('txtWi1TypeDmName chkWanConnRstEnable txtWanConnRstHour txtWanConnRstMin txtWanConnRstDelay', '', 'txtWi1TypeAcName rdbWi1TypeKeepConn txtWi1TypeServIpAddr', 'tblWi1TypeMyIpAddr tblWi1TypePPPServIpAddr tblWi1IpAddrSection');
     	idleTimeOutCheck ();
		ipAddrCheck ();
		}
	}
	
function wan1IspOtherEnable ()
	{
	if (document.getElementById('rdbWi1TypeOther').checked)
		{
		fieldStateChangeWr ('txtWi1TypeServIpAddr', 'tblWi1TypeMyIpAddr tblWi1TypePPPServIpAddr', 'txtWi1TypeAcName txtWi1TypeDmName rdbWi1TypeKeepConn chkWanConnRstEnable', 'tblWi1IpAddrSection');
     	idleTimeOutCheck ();
		ipAddrCheck ();
		wanConnRstCkeck ();
		}
	}
function wanTest (currWanId)
	{
    if (hdPrimWanId.value != null)
        {
        var primWanId = parseInt (hdPrimWanId.value, 10);

        if (currWanId == primWanId)
            {
          	window.open('http://www.netgear.com');
            return;
            }
        }
   
    switch (currWanId)
        {
        case 0:  /* WAN1 */
             alert ("The test can be performed after setting WAN Mode to " +
                    "Single Port and selecting Primary Port as WAN1.");
             break;
        case 1:  /* WAN2 */
             alert ("The test can be performed after setting WAN Mode to " +
                    "Single Port and selecting Primary Port as WAN2.");
             break;
        default:
             return;
        }
    return;
	}
function wanConnRstCkeck ()
	{
	depFieldCheck ('chkWanConnRstEnable', true, '', '', 'txtWanConnRstHour txtWanConnRstMin txtWanConnRstDelay', '');
	depFieldCheck ('chkWanConnRstEnable', false, 'txtWanConnRstHour txtWanConnRstMin txtWanConnRstDelay', '', '', '');
	}
